function login() {
	var data = {'type':'login', 'email': document.getElementById('email').value, 'password': document.getElementById('password').value};
	request(data, function(response) {
		document.write(response.error == 0 ? "success" : "wrong user/pass");
	});
}

function submitForm(type, form) {
	var data = {};
	$(form).find('*[name]').each(function(i) {
		data[$(this).attr('name')] = $(this).val()
	});
	request(type, data);
	return false;
}

function logout() {
	request("logout");
}

function goToIdeasForum() {
    request("goToIdeasForum");
}

function goToWebsite() {
    request("goToWebsite");
}

function showSettings() {
    request("showSettings");
}

function showButton(uuid) {
	request("showButton", {buttonUuid: buttonUuid});
}

function listActionTypes(buttonUuid, trigger) {
	request("listActionTypes", {buttonUuid: buttonUuid, trigger: trigger});
}

function editAction(buttonUuid, actionType, trigger, actionId) {
	request("editAction", {buttonUuid: buttonUuid, trigger: trigger, actionType: actionType, actionUuid: actionUuid});
}

function cellChangedEvent(event) {
	request("cellInteraction", event);
}

function listProviders() {
    request("listProviders");
}

function showProvider(identifier) {
    request("showProvider", {identifier: identifier});
}

function scanFlic() {
    request("scanFlic");
}

function addNewTask() {
    request("addNewTask");
}

function welcomeScreen() {
    request("welcomeScreen");
}

function backButton() {
    request("backButtonPressed");
}

// Change listeners

var segmentCellValueChanged = function(sender, id, value) {
    $(sender).addClass('horizontal-select-div-element-selected').siblings().removeClass('horizontal-select-div-element-selected');
    $('#' + id).val(value);
    cellChangedEvent( { id: id, type: "valueChanged", value: value } );
};

var switchCellValueChanged = function(sender, id, value) {
    $(sender).addClass('horizontal-select-div-element-selected').siblings().removeClass('horizontal-select-div-element-selected');
    $('#' + id).val(value);
    cellChangedEvent( { id: id, type: "valueChanged", value: value } );
};

var readMoreCellInteraction = function(id) {
    var state = "collapsed";
    if ($('#flic-cell-read-more-id').is(":visible")) {
        state = "expanded";
    }
    cellChangedEvent( { id: id, type: "stateChanged", state: state } );
};

var labelWithButtonPressed = function(id) {
    cellChangedEvent( { id: id, type: "buttonPressed" } );
}

var buttonPressed = function(id) {
    cellChangedEvent( { id: id, type: "buttonPressed" } );
}

var textFieldInteraction = function(id, type) {
    if (type == 'valueChanged') {
        // TODO: Possibly do some validation here..
        cellChangedEvent( { id: id, type: type, value: $('#'+id).val() } );
    } else if (type == 'onEnter') {
        if (event.keyCode == 13) {
            cellChangedEvent( { id: id, type: "onEnter"} );
        }
    } else {
        cellChangedEvent( { id: id, type: "stateChanged", state: "focused" } );
    }
};

var sliderInteraction = function(id, type) {
    if (type == 'valueChanged') {
        // TODO: Possibly do some validation here..
        cellChangedEvent( { id: id, type: type, value: $('#'+id).val() } );
    }
};

var colorPickerInteraction = function(id, type, parameter) {
    var hue = $('#'+id+'_hue').val();
    var saturation = $('#'+id+'_saturation').val();
    var brightness = $('#'+id+'_brightness').val();
    $('#color_preview').css('background', 'hsl('+((hue/100)*360)+','+saturation+'%,'+brightness+'%)');
    cellChangedEvent( { id: id, type: type, value: {hue: hue, saturation: saturation, brightness: brightness } } );
}

function pickColor(id, mode, hue, saturation, brightness, temperature) {
	request("pickColor", {mode: mode, hue: hue, saturation: saturation, brightness: brightness, temperature: temperature}, function(data) {
		cellChangedEvent( { id: id, type: 'valueChanged', value: {mode: data.mode, hue: data.hue, saturation: data.saturation, brightness: data.brightness, temperature: data.temperature}});
	});
}

var groupCheckInteraction = function(id, value, type) {
    if (type == 'valueChanged') {
        var inputElement = $('#'+id+'_'+value.replace(' ', '\\ '))[0];
        if ($(inputElement).val() == $('input[name=' + id + ']:checked').val()) {
            // TODO: For now I dont allow unchecking...
        } else {
            $(inputElement).prop('checked', true);
        }
        cellChangedEvent( { id: id, type: type, value: $('input[name=' + id + ']:checked').val() });
    }
};

var checkInteraction = function(id, value, type) {
    if (type == 'valueChanged') {
        var inputElement = $('#'+id+'_'+value.replace(' ', '\\ '))[0];

        if (inputElement.checked) {
            $(inputElement).prop('checked', false);
        } else {
            $(inputElement).prop('checked', true);
        }

        var checkedValues = [];
        $.each($('input[name=' + id + ']:checked'), function(){
               checkedValues.push($(this).val());
               });
        cellChangedEvent( { id: id, type: type, value: checkedValues } );
    }
};

function boinkSidebarButton(button) {
    $('#sidebar-flic-' + button.uuid).removeClass('boink');
    setTimeout(function() { $('#sidebar-flic-' + button.uuid).addClass('boink'); }, 10);
}

function alertViewButtonPress(id, type) {
    hidePopups();
    request("alertViewInteraction", { id: id, type: type } );
}

function hidePopups() {
    $('#popupBackgroundScreen').hide();
    $('#popupScreen').hide();
    $('#buttonDetailsPopup').hide();
    $('#editActionDetailsPopup').hide();
}

function showMainPopup(data) {
    $('#popupScreenTitle').html(data.title);
    $('#popupScreenText').html(data.description);
    
    /*
    $('#popupBackgroundScreen').onclick = function() {
        alertViewButtonPress(data.id, 'rightButton');
    };
    
    $('#alertViewRightButton').onclick = function() {
        alertViewButtonPress(data.id, 'rightButton');
    };
    
    click
     */
    
    //$('#popupBackgroundScreen').click( function() { alertViewButtonPress(data.id, 'rightButton'); } );
    //$('#alertViewRightButton').click( function() { alertViewButtonPress(data.id, 'rightButton'); } );
    
    //$('#alertViewRightButton').off("click", "**");
    
    $('#popupBackgroundScreen').off();
    $('#alertViewRightButton').off();
    $('#alertViewLeftButton').off();
    $('#alertViewRightButton').html(data.rightButtonTitle);
    
    if (data.leftButton) {
        $('#alertViewRightButton').on("click", function(){ alertViewButtonPress(data.id, 'rightButton'); });
        $('#alertViewLeftButton').on("click", function(){ alertViewButtonPress(data.id, 'leftButton'); });
        $('#popupBackgroundScreen').on("click", function(){ alertViewButtonPress(data.id, 'leftButton'); });
        $('#alertViewLeftButton').html(data.leftButtonTitle);
        $('#alertViewLeftButton').removeClass("displaynone");
    } else {
        $('#alertViewRightButton').on("click", function(){ alertViewButtonPress(data.id, 'rightButton'); });
        $('#popupBackgroundScreen').on("click", function(){ alertViewButtonPress(data.id, 'rightButton'); });
        $('#alertViewLeftButton').addClass("displaynone");
    }
    
    
    
    //displaynone
    
    $('#popupScreen').show();
    $('#popupBackgroundScreen').show();
}

function showButtonConfigPopup() {
    $('#popupBackgroundScreen').show();
    $('#buttonDetailsPopup').show();
}

function showEditActionDetailsPopup() {
    $('#popupBackgroundScreen').show();
    $('#editActionDetailsPopup').show();
}

$(function(){
	request("init");
});
